diff --git a/MAINTAINERS b/MAINTAINERS
index 42ddfbd8c..7ab7728f4 100644
--- a/MAINTAINERS
+++ b/MAINTAINERS
@@ -321,6 +321,7 @@ M: Hemant Agrawal <hemant.agrawal@nxp.com>
 F: lib/librte_rawdev/*
 F: drivers/rawdev/skeleton/*
 F: test/test/test_rawdev.c
+F: doc/guides/prog_guide/rawdev_lib.rst
 
 
 Bus Drivers
diff --git a/doc/api/doxy-api-index.md b/doc/api/doxy-api-index.md
index 59281a109..4259b517a 100644
--- a/doc/api/doxy-api-index.md
+++ b/doc/api/doxy-api-index.md
@@ -43,6 +43,7 @@ The public API headers are grouped by topics:
   [rte_tm]             (@ref rte_tm.h),
   [rte_mtr]            (@ref rte_mtr.h),
   [bbdev]              (@ref rte_bbdev.h),
+  [rawdev]             (@ref rte_rawdev.h),
   [cryptodev]          (@ref rte_cryptodev.h),
   [security]           (@ref rte_security.h),
   [eventdev]           (@ref rte_eventdev.h),
diff --git a/doc/api/doxy-api.conf b/doc/api/doxy-api.conf
index d4a72abc6..cda52fdfb 100644
--- a/doc/api/doxy-api.conf
+++ b/doc/api/doxy-api.conf
@@ -71,6 +71,7 @@ INPUT                   = doc/api/doxy-api-index.md \
                           lib/librte_pipeline \
                           lib/librte_port \
                           lib/librte_power \
+                          lib/librte_rawdev \
                           lib/librte_reorder \
                           lib/librte_ring \
                           lib/librte_sched \
diff --git a/doc/guides/prog_guide/index.rst b/doc/guides/prog_guide/index.rst
index af5f65a33..beead3105 100644
--- a/doc/guides/prog_guide/index.rst
+++ b/doc/guides/prog_guide/index.rst
@@ -75,6 +75,7 @@ Programmer's Guide
     vhost_lib
     metrics_lib
     port_hotplug_framework
+    rawdev_lib
     source_org
     dev_kit_build_system
     dev_kit_root_make_help
diff --git a/doc/guides/prog_guide/rawdev_lib.rst b/doc/guides/prog_guide/rawdev_lib.rst
new file mode 100644
index 000000000..54bffc585
--- /dev/null
+++ b/doc/guides/prog_guide/rawdev_lib.rst
@@ -0,0 +1,107 @@
+..  SPDX-License-Identifier: BSD-3-Clause
+    Copyright 2018 NXP
+
+Rawdevice Library
+=================
+
+Introduction
+------------
+
+In terms of device flavor (type) support, DPDK currently has ethernet
+(lib_ether), cryptodev (libcryptodev), eventdev (libeventdev) and vdev
+(virtual device) support.
+
+For a new type of device, for example an accelerator, there are not many
+options except:
+1. create another lib/librte_MySpecialDev, driver/MySpecialDrv and use it
+through Bus/PMD model.
+2. Or, create a vdev and implement necessary custom APIs which are directly
+exposed from driver layer. However this may still require changes in bus code
+in DPDK.
+
+The DPDK Rawdev library is an abstraction that provides the DPDK framework a
+way to manage such devices in a generic manner without expecting changes to
+library or EAL for each device type. This library provides a generic set of
+operations and APIs for framework and Applications to use, respectively, for
+interfacing with such type of devices.
+
+Design
+------
+
+Key factors guiding design of the Rawdevice library:
+
+1. Following are some generic operations which can be treated as applicable
+   to a large subset of device types. None of the operations are mandatory to
+   be implemented by a driver. Application should also be design for proper
+   handling for unsupported APIs.
+
+  * Device Start/Stop - In some cases, 'reset' might also be required which
+    has different semantics than a start-stop-start cycle.
+  * Configuration - Device, Queue or any other sub-system configuration
+  * I/O - Sending a series of buffers which can enclose any arbitrary data
+  * Statistics - Fetch arbitrary device statistics
+  * Firmware Management - Firmware load/unload/status
+
+2. Application API should be able to pass along arbitrary state information
+   to/fro device driver. This can be achieved by maintaining context
+   information through opaque data or pointers.
+
+Figure below outlines the layout of the rawdevice library and device vis-a-vis
+other well known device types like eth and crypto:
+
+.. code-block:: console
+
+     +-----------------------------------------------------------+
+     |                        Application(s)                     |
+     +------------------------------.----------------------------+
+                                    |
+                                    |
+     +------------------------------'----------------------------+
+     |                     DPDK Framework (APIs)                 |
+     +--------------|----|-----------------|---------------------+
+                   /      \                 \
+            (crypto ops)  (eth ops)      (rawdev ops)        +----+
+            /               \                 \              |DrvA|
+     +-----'---+        +----`----+        +---'-----+       +----+
+     | crypto  |        | ethdev  |        | raw     |
+     +--/------+        +---/-----+        +----/----+       +----+
+       /\                __/\                  /   ..........|DrvB|
+      /  \              /    \                / ../    \     +----+
+  +====+ +====+    +====+ +====+            +==/=+      ```Bus Probe
+  |DevA| |DevB|    |DevC| |DevD|            |DevF|
+  +====+ +====+    +====+ +====+            +====+
+    |      |        |      |                 |
+  ``|``````|````````|``````|`````````````````|````````Bus Scan
+   (PCI)   |       (PCI)  (PCI)            (PCI)
+         (BusA)
+
+ * It is assumed above that DrvB is a PCI type driver which registers itself
+   with PCI Bus
+ * Thereafter, when the PCI scan is done, during probe DrvB would match the
+   rawdev DevF ID and take control of device
+ * Applications can then continue using the device through rawdev API
+   interfaces
+
+
+Device Identification
+~~~~~~~~~~~~~~~~~~~~~
+
+Physical rawdev devices are discovered during the Bus scan executed at DPDK
+initialization, based on their identification and probing with corresponding
+driver. Thus, a generic device needs to have an identifier and a driver
+capable of identifying it through this identifier.
+
+Virtual devices can be created by two mechanisms, either using the EAL command
+line options or from within the application using an EAL API directly.
+
+From the command line using the --vdev EAL option
+
+.. code-block:: console
+
+   --vdev 'rawdev_dev1'
+
+Our using the rte_vdev_init API within the application code.
+
+.. code-block:: c
+
+    rte_vdev_init("rawdev_dev1", NULL)
diff --git a/doc/guides/rel_notes/release_18_02.rst b/doc/guides/rel_notes/release_18_02.rst
index 84e0ad068..ce5ccaf9d 100644
--- a/doc/guides/rel_notes/release_18_02.rst
+++ b/doc/guides/rel_notes/release_18_02.rst
@@ -192,6 +192,17 @@ New Features
     is unaffected by these changes, and can continue to be used for this
     and subsequent releases until such time as it's deprecation is announced.
 
+* **Added Rawdev, a generic device support library.**
+
+  Rawdev library provides support for integrating any generic device type with
+  DPDK framework. Generic devices are those which do not have a pre-defined
+  type within DPDK, for example, ethernet, crypto, event etc.
+  A set of northbound APIs have been defined which encompass a generic set of
+  operations by allowing applications to interact with device using opaque
+  structures/buffers. Also, southbound APIs provide APIs for integrating device
+  either as as part of a physical bus (PCI, FSLMC etc) or through ``vdev``.
+
+  See the :doc:`../prog_guide/rawdev_lib` programmer's guide for more details.
 
 API Changes
 -----------
@@ -308,6 +319,7 @@ The libraries prepended with a plus sign were incremented in this version.
      librte_pmd_vhost.so.2
      librte_port.so.3
      librte_power.so.1
+     librte_rawdev.so.1
      librte_reorder.so.1
      librte_ring.so.1
      librte_sched.so.1