diff --git a/MAINTAINERS b/MAINTAINERS
index aa30bd9..30a9911 100644
--- a/MAINTAINERS
+++ b/MAINTAINERS
@@ -486,15 +486,15 @@ F: drivers/net/mlx5/
 F: doc/guides/nics/mlx5.rst
 F: doc/guides/nics/features/mlx5.ini

-Marvell mrvl
+Marvell mvpp2
 M: Jacek Siuda <jck@semihalf.com>
 M: Tomasz Duszynski <tdu@semihalf.com>
 M: Dmitri Epshtein <dima@marvell.com>
 M: Natalie Samsonov <nsamsono@marvell.com>
 M: Jianbo Liu <jianbo.liu@arm.com>
-F: drivers/net/mrvl/
-F: doc/guides/nics/mrvl.rst
-F: doc/guides/nics/features/mrvl.ini
+F: drivers/net/mvpp2/
+F: doc/guides/nics/mvpp2.rst
+F: doc/guides/nics/features/mvpp2.ini

 Microsoft vdev_netvsc - EXPERIMENTAL
 M: Matan Azrad <matan@mellanox.com>
diff --git a/config/common_base b/config/common_base
index ee10b44..7abf7c6 100644
--- a/config/common_base
+++ b/config/common_base
@@ -383,7 +383,7 @@ CONFIG_RTE_LIBRTE_PMD_FAILSAFE=y
 #
 # Compile Marvell PMD driver
 #
-CONFIG_RTE_LIBRTE_MRVL_PMD=n
+CONFIG_RTE_LIBRTE_MVPP2_PMD=n

 #
 # Compile virtual device driver for NetVSC on Hyper-V/Azure
diff --git a/doc/guides/cryptodevs/mrvl.rst b/doc/guides/cryptodevs/mrvl.rst
index 6a0b08c..443ebcd 100644
--- a/doc/guides/cryptodevs/mrvl.rst
+++ b/doc/guides/cryptodevs/mrvl.rst
@@ -86,7 +86,7 @@ Currently there are two driver specific compilation options in
     Toggle display of debugging messages.

 For a list of prerequisites please refer to `Prerequisites` section in
-:ref:`MRVL Poll Mode Driver <mrvl_poll_mode_driver>` guide.
+:ref:`MVPP2 Poll Mode Driver <mvpp2_poll_mode_driver>` guide.

 MRVL CRYPTO PMD requires MUSDK built with EIP197 support thus following
 extra option must be passed to the library configuration script:
@@ -123,7 +123,7 @@ operation:

 .. code-block:: console

-   ./l2fwd-crypto --vdev=net_mrvl,iface=eth0 --vdev=crypto_mrvl -- \
+   ./l2fwd-crypto --vdev=eth_mvpp2,iface=eth0 --vdev=crypto_mrvl -- \
      --cipher_op ENCRYPT --cipher_algo aes-cbc \
      --cipher_key 00:01:02:03:04:05:06:07:08:09:0a:0b:0c:0d:0e:0f  \
      --auth_op GENERATE --auth_algo sha1-hmac \
diff --git a/doc/guides/nics/features/mrvl.ini b/doc/guides/nics/features/mvpp2.ini
similarity index 90%
rename from doc/guides/nics/features/mrvl.ini
rename to doc/guides/nics/features/mvpp2.ini
index 8673a56..ef47546 100644
--- a/doc/guides/nics/features/mrvl.ini
+++ b/doc/guides/nics/features/mvpp2.ini
@@ -1,5 +1,5 @@
 ;
-; Supported features of the 'mrvl' network poll mode driver.
+; Supported features of the 'mvpp2' network poll mode driver.
 ;
 ; Refer to default.ini for the full list of available PMD features.
 ;
diff --git a/doc/guides/nics/index.rst b/doc/guides/nics/index.rst
index 59419f4..51c453d 100644
--- a/doc/guides/nics/index.rst
+++ b/doc/guides/nics/index.rst
@@ -30,7 +30,7 @@ Network Interface Controller Drivers
     liquidio
     mlx4
     mlx5
-    mrvl
+    mvpp2
     nfp
     octeontx
     qede
diff --git a/doc/guides/nics/mrvl.rst b/doc/guides/nics/mvpp2.rst
similarity index 96%
rename from doc/guides/nics/mrvl.rst
rename to doc/guides/nics/mvpp2.rst
index f9ec9d6..0408752 100644
--- a/doc/guides/nics/mrvl.rst
+++ b/doc/guides/nics/mvpp2.rst
@@ -29,12 +29,12 @@
     (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
     OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

-.. _mrvl_poll_mode_driver:
+.. _mvpp2_poll_mode_driver:

-MRVL Poll Mode Driver
+MVPP2 Poll Mode Driver
 ======================

-The MRVL PMD (librte_pmd_mrvl) provides poll mode driver support
+The MVPP2 PMD (librte_pmd_mvpp2) provides poll mode driver support
 for the Marvell PPv2 (Packet Processor v2) 1/10 Gbps adapter.

 Detailed information about SoCs that use PPv2 can be obtained here:
@@ -52,7 +52,7 @@ Detailed information about SoCs that use PPv2 can be obtained here:
 Features
 --------

-Features of the MRVL PMD are:
+Features of the MVPP2 PMD are:

 - Speed capabilities
 - Link status
@@ -136,9 +136,9 @@ Config File Options

 The following options can be modified in the ``config`` file.

-- ``CONFIG_RTE_LIBRTE_MRVL_PMD`` (default ``n``)
+- ``CONFIG_RTE_LIBRTE_MVPP2_PMD`` (default ``n``)

-    Toggle compilation of the librte_pmd_mrvl driver.
+    Toggle compilation of the librte mvpp2 driver.


 QoS Configuration
@@ -294,7 +294,7 @@ Usage example

 .. code-block:: console

-   ./testpmd --vdev=eth_mrvl,iface=eth0,iface=eth2,cfg=/home/user/mrvl.conf \
+   ./testpmd --vdev=eth_mvpp2,iface=eth0,iface=eth2,cfg=/home/user/mrvl.conf \
      -c 7 -- -i -a --disable-hw-vlan-strip --rxq=3 --txq=3


@@ -321,7 +321,7 @@ the path to the MUSDK installation directory needs to be exported.
    export LIBMUSDK_PATH=<musdk>/usr/local
    export CROSS=aarch64-linux-gnu-
    make config T=arm64-armv8a-linuxapp-gcc
-   sed -ri 's,(MRVL_PMD=)n,\1y,' build/.config
+   sed -ri 's,(MVPP2_PMD=)n,\1y,' build/.config
    make

 Flow API
@@ -428,7 +428,7 @@ Before proceeding run testpmd user application:

 .. code-block:: console

-   ./testpmd --vdev=net_mrvl,iface=eth0,iface=eth2 -c 3 -- -i --p 3 -a --disable-hw-vlan-strip
+   ./testpmd --vdev=eth_mvpp2,iface=eth0,iface=eth2 -c 3 -- -i --p 3 -a --disable-hw-vlan-strip

 Example #1
 ^^^^^^^^^^
@@ -492,7 +492,7 @@ For additional information about classifier please consult
 Usage Example
 -------------

-MRVL PMD requires extra out of tree kernel modules to function properly.
+MVPP2 PMD requires extra out of tree kernel modules to function properly.
 `musdk_uio` and `mv_pp_uio` sources are part of the MUSDK. Please consult
 ``doc/musdk_get_started.txt`` for the detailed build instructions.
 For `mvpp2x_sysfs` please consult ``Documentation/pp22_sysfs.txt`` for the
@@ -515,6 +515,6 @@ In order to run testpmd example application following command can be used:

 .. code-block:: console

-   ./testpmd --vdev=eth_mrvl,iface=eth0,iface=eth2 -c 7 -- \
+   ./testpmd --vdev=eth_mvpp2,iface=eth0,iface=eth2 -c 7 -- \
      --burst=128 --txd=2048 --rxd=1024 --rxq=2 --txq=2  --nb-cores=2 \
      -i -a --rss-udp
diff --git a/drivers/net/Makefile b/drivers/net/Makefile
index 39eb550..37ca19a 100644
--- a/drivers/net/Makefile
+++ b/drivers/net/Makefile
@@ -31,7 +31,7 @@ DIRS-$(CONFIG_RTE_LIBRTE_IXGBE_PMD) += ixgbe
 DIRS-$(CONFIG_RTE_LIBRTE_LIO_PMD) += liquidio
 DIRS-$(CONFIG_RTE_LIBRTE_MLX4_PMD) += mlx4
 DIRS-$(CONFIG_RTE_LIBRTE_MLX5_PMD) += mlx5
-DIRS-$(CONFIG_RTE_LIBRTE_MRVL_PMD) += mrvl
+DIRS-$(CONFIG_RTE_LIBRTE_MVPP2_PMD) += mvpp2
 DIRS-$(CONFIG_RTE_LIBRTE_NFP_PMD) += nfp
 DIRS-$(CONFIG_RTE_LIBRTE_BNXT_PMD) += bnxt
 DIRS-$(CONFIG_RTE_LIBRTE_PMD_NULL) += null
@@ -59,7 +59,7 @@ ifeq ($(CONFIG_RTE_LIBRTE_VHOST),y)
 DIRS-$(CONFIG_RTE_LIBRTE_PMD_VHOST) += vhost
 endif # $(CONFIG_RTE_LIBRTE_VHOST)

-ifeq ($(CONFIG_RTE_LIBRTE_MRVL_PMD),y)
+ifeq ($(CONFIG_RTE_LIBRTE_MVPP2_PMD),y)
 ifeq ($(CONFIG_RTE_LIBRTE_CFGFILE),n)
 $(error "RTE_LIBRTE_CFGFILE must be enabled in configuration!")
 endif
diff --git a/drivers/net/mrvl/Makefile b/drivers/net/mvpp2/Makefile
similarity index 83%
rename from drivers/net/mrvl/Makefile
rename to drivers/net/mvpp2/Makefile
index 31a8fda..2383ec1 100644
--- a/drivers/net/mrvl/Makefile
+++ b/drivers/net/mvpp2/Makefile
@@ -14,7 +14,7 @@ endif
 endif

 # library name
-LIB = librte_pmd_mrvl.a
+LIB = librte_pmd_mvpp2.a

 # library version
 LIBABIVER := 1
@@ -35,8 +35,8 @@ LDLIBS += -lrte_ethdev -lrte_net -lrte_kvargs -lrte_cfgfile
 LDLIBS += -lrte_bus_vdev

 # library source files
-SRCS-$(CONFIG_RTE_LIBRTE_MRVL_PMD) += mrvl_ethdev.c
-SRCS-$(CONFIG_RTE_LIBRTE_MRVL_PMD) += mrvl_qos.c
-SRCS-$(CONFIG_RTE_LIBRTE_MRVL_PMD) += mrvl_flow.c
+SRCS-$(CONFIG_RTE_LIBRTE_MVPP2_PMD) += mrvl_ethdev.c
+SRCS-$(CONFIG_RTE_LIBRTE_MVPP2_PMD) += mrvl_qos.c
+SRCS-$(CONFIG_RTE_LIBRTE_MVPP2_PMD) += mrvl_flow.c

 include $(RTE_SDK)/mk/rte.lib.mk
diff --git a/drivers/net/mrvl/mrvl_ethdev.c b/drivers/net/mvpp2/mrvl_ethdev.c
similarity index 99%
rename from drivers/net/mrvl/mrvl_ethdev.c
rename to drivers/net/mvpp2/mrvl_ethdev.c
index c0483b9..6ab515c 100644
--- a/drivers/net/mrvl/mrvl_ethdev.c
+++ b/drivers/net/mvpp2/mrvl_ethdev.c
@@ -2828,5 +2828,5 @@ static struct rte_vdev_driver pmd_mrvl_drv = {
 	.remove = rte_pmd_mrvl_remove,
 };

-RTE_PMD_REGISTER_VDEV(net_mrvl, pmd_mrvl_drv);
-RTE_PMD_REGISTER_ALIAS(net_mrvl, eth_mrvl);
+RTE_PMD_REGISTER_VDEV(net_mvpp2, pmd_mrvl_drv);
+RTE_PMD_REGISTER_ALIAS(net_mvpp2, eth_mvpp2);
diff --git a/drivers/net/mrvl/mrvl_ethdev.h b/drivers/net/mvpp2/mrvl_ethdev.h
similarity index 100%
rename from drivers/net/mrvl/mrvl_ethdev.h
rename to drivers/net/mvpp2/mrvl_ethdev.h
diff --git a/drivers/net/mrvl/mrvl_flow.c b/drivers/net/mvpp2/mrvl_flow.c
similarity index 100%
rename from drivers/net/mrvl/mrvl_flow.c
rename to drivers/net/mvpp2/mrvl_flow.c
diff --git a/drivers/net/mrvl/mrvl_qos.c b/drivers/net/mvpp2/mrvl_qos.c
similarity index 100%
rename from drivers/net/mrvl/mrvl_qos.c
rename to drivers/net/mvpp2/mrvl_qos.c
diff --git a/drivers/net/mrvl/mrvl_qos.h b/drivers/net/mvpp2/mrvl_qos.h
similarity index 100%
rename from drivers/net/mrvl/mrvl_qos.h
rename to drivers/net/mvpp2/mrvl_qos.h
diff --git a/drivers/net/mrvl/rte_pmd_mrvl_version.map b/drivers/net/mvpp2/rte_pmd_mrvl_version.map
similarity index 100%
rename from drivers/net/mrvl/rte_pmd_mrvl_version.map
rename to drivers/net/mvpp2/rte_pmd_mrvl_version.map
diff --git a/mk/rte.app.mk b/mk/rte.app.mk
index 94525dc..a9b4b05 100644
--- a/mk/rte.app.mk
+++ b/mk/rte.app.mk
@@ -164,7 +164,7 @@ _LDLIBS-$(CONFIG_RTE_LIBRTE_MLX5_PMD)       += -lrte_pmd_mlx5 -ldl
 else
 _LDLIBS-$(CONFIG_RTE_LIBRTE_MLX5_PMD)       += -lrte_pmd_mlx5 -libverbs -lmlx5
 endif
-_LDLIBS-$(CONFIG_RTE_LIBRTE_MRVL_PMD)       += -lrte_pmd_mrvl -L$(LIBMUSDK_PATH)/lib -lmusdk
+_LDLIBS-$(CONFIG_RTE_LIBRTE_MVPP2_PMD)      += -lrte_pmd_mvpp2 -L$(LIBMUSDK_PATH)/lib -lmusdk
 _LDLIBS-$(CONFIG_RTE_LIBRTE_NFP_PMD)        += -lrte_pmd_nfp
 _LDLIBS-$(CONFIG_RTE_LIBRTE_PMD_NULL)       += -lrte_pmd_null
 _LDLIBS-$(CONFIG_RTE_LIBRTE_PMD_PCAP)       += -lrte_pmd_pcap -lpcap